/************************************************************************ *********
 * FIRICA N. ALEXANDRA - NICOLETA
 * 			331CB
 *********************************************************************************/


/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 * PROIECT - cub de leduri
 *********************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <stdlib.h>

#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>


void initLED()
{
	

	DDRA=0;//restez toti bitii la 0
	DDRB=1;
	DDRD=1;

	//pinii de la 0 la 3 sunt pinii care comanda fiecare layer -> sunt pini de iesire
	DDRA |=(1<<0)|(1<<1)|(1<<2)|(1<<3);
	//initializez pinul pentru o coloana
	DDRB |= 0x01;
	DDRC |= 0xFF;

	DDRD |= _BV(PD7);				// initializare pin pentru LED placa initiala-> setez directia de intrare/iesire

}



void initTimer()
{
	//Compare value: with 1024 prescaling => a 1s timer
	OCR1A = 15625;
	
	//Enable interrupt
	TIMSK |= _BV(OCIE1A);		
	
	//Compare mode: PWM, phase and frequency correct, TOP = OCCR1A
	TCCR1B |= _BV(WGM13); 
	TCCR1A |= _BV(WGM10);
	
	//Clock prescaler =  1024
	TCCR1B |= _BV(CS12);
	TCCR1B &= ~_BV(CS11);
	TCCR1B |= _BV(CS10);
}

//functia ISR se va aplica o data pe secunda
ISR(TIMER1_COMPA_vect)
{
	PORTD ^= (1<<PD7);	// schimbare stare LED

	PORTA ^=((1<<PA0)|(1<<PA1)|(1<<PA2)|(1<<PA3));	//schimbare stare layer 1 (de sus)

	PORTB ^= (1<<PB7);
	PORTC ^= (1<<PC0)|(1<<PC1)|(1<<PC2)|(1<<PC3)|(1<<PC4)|(1<<PC5)|(1<<PC6)|(1<<PC7);


}

int main()
{
	sei();//porneste intreruperile

	initLED();
	initTimer();
	
	while(1){};
	
	return 0;
}
